// gcc -Wall -Wpedantic -Wextra -std=c17 -march=haswell -O1 bitfield.c

#include <stdint.h>
#include <stdio.h>

// https://capitalizemytitle.com/random-adjective-generator/

#define BIT_FIELD uint8_t
#define TALL  0x01          // 00000001
#define SHARP 0x02          // 00000010
#define LOUD  0x04          // 00000100
#define COOL  0x08          // 00001000
#define SHY   0x10          // 00010000

void is_loud(BIT_FIELD record) {
    if ( record & LOUD ) {
        printf("is loud\n");
    } else {
        printf("is not loud\n");
    }
}

int main() {
    BIT_FIELD record = SHARP | LOUD;
    
    is_loud(record);
    
    // clear the LOUD bit
    record &= ~LOUD;
    is_loud(record);

    // set the LOUD bit
    record |= LOUD;
    is_loud(record);
    
    return 0;
}
